Attribute VB_Name = "APIs"
Option Explicit

Public Const SW_SHOWNORMAL = 1

Private Const MAX_PATH = 260
Public Const LB_SETTABSTOPS = &H192

Global g_OldWndProc As Long

Public Const GWL_WNDPROC = (-4)
Public Const GWL_HINSTANCE = (-6)
Public Const WM_LBUTTONUP = &H202
Public Const WM_LBUTTONDOWN = &H201
Public Const WM_MOUSEMOVE = &H200
Public Const WM_USER = &H400
Public Const CF_BITMAP = 2
Public Const FW_NORMAL = 400
Public Const FW_BOLD = 700
Public Const WM_SETFONT = &H30
Public Const WM_GETFONT = &H31
'**********************************
'**  Constant Definitions:'Windows eventsPublic
Const WM_NCHITTEST& = &H84
Public Const WM_NCACTIVATE& = &H86
Public Const WM_NCCALCSIZE& = &H83
Public Const WM_NCCREATE& = &H81
Public Const WM_NCDESTROY& = &H82
Public Const WM_NCLBUTTONDBLCLK& = &HA3
Public Const WM_NCLBUTTONDOWN& = &HA1
Public Const WM_NCLBUTTONUP& = &HA2
Public Const WM_NCMBUTTONDBLCLK& = &HA9
Public Const WM_NCMBUTTONDOWN& = &HA7
Public Const WM_NCMBUTTONUP& = &HA8
Public Const WM_NCMOUSEMOVE& = &HA0
Public Const WM_SIZE = &H5
Public Const WM_GETMINMAXINFO = &H24
'**********************************
'**  Constant Definitions:
Public Const HTBORDER& = 18
Public Const HTBOTTOM& = 15
Public Const HTBOTTOMLEFT& = 16
Public Const HTBOTTOMRIGHT& = 17
Public Const HTCAPTION& = 2
Public Const HTCLIENT& = 1
Public Const HTCLOSE& = 20
Public Const HTERROR& = (-2)
Public Const HTGROWBOX& = 4
Public Const HTHELP& = 21
Public Const HTLEFT& = 10
Public Const HTHSCROLL& = 6
Public Const HTMAXBUTTON& = 9
Public Const HTMENU& = 5
Public Const HTMINBUTTON& = 8
Public Const HTNOWHERE& = 0
Public Const HTOBJECT& = 19
Public Const HTREDUCE& = HTMINBUTTON
Public Const HTRIGHT& = 11
Public Const HTSIZE& = HTGROWBOX
Public Const HTSIZEFIRST& = HTLEFT
Public Const HTSIZELAST& = HTBOTTOMRIGHT
Public Const HTSYSMENU& = 3
Public Const HTTOP& = 12
Public Const HTTOPLEFT& = 13
Public Const HTTOPRIGHT& = 14
Public Const HTTRANSPARENT& = (-1)
Public Const HTVSCROLL& = 7
Public Const HTZOOM& = HTMAXBUTTON
Public Const LF_FACESIZE = 32
'
Public Const MAX_WIDTH = 1000
Public Const MAX_HEIGHT = 750
Public Const MIN_WIDTH = 570
Public Const MIN_HEIGHT = 285


Type POINTAPI  '  8 Bytes
     X As Long
     Y As Long
End Type

Public Type MINMAXINFO  '  4 Bytes
    ptReserved As POINTAPI
    ptMaxSize As POINTAPI
    ptMaxPosition As POINTAPI
    ptMinTrackSize As POINTAPI
    ptMaxTrackSize As POINTAPI
End Type

' Costanti per lo stile della toolbar.
'Public Const WM_USER = &H400
Public Const TBSTYLE_TRANSPARENT = &H8000
Public Const TBSTYLE_FLAT = &H800
Public Const TB_SETSTYLE = (WM_USER + 56)
Public Const TB_GETSTYLE = (WM_USER + 57)
Public Const CCS_NODIVIDER = &H40

' Funzione API FindWindowEx.
Public Declare Function FindWindowEx Lib "user32" Alias "FindWindowExA" _
                        (ByVal hWnd1 As Long, _
                        ByVal hWnd2 As Long, _
                        ByVal lpsz1 As String, _
                        ByVal lpsz2 As String) As Long
                                                                                                                                                                  
' Funzione API SendMessage.
' OSS: gi dichiarata nel modulo mListView
'Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
                        (ByVal hwnd As Long, _
                        ByVal wMsg As Long, _
                        ByVal wParam As Integer, _
                        ByVal lParam As Any) As Long


'Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
'Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (dest As Any, Source As Any, ByVal Length As Long)
Declare Sub CopyMemoryFromPointer Lib "kernel32" Alias "RtlMoveMemory" (dest As Any, ByVal Source As Long, ByVal Length As Long)

Private Declare Function GetTempPath Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long

Private Declare Function GetTempFileName Lib "kernel32" Alias "GetTempFileNameA" (ByVal lpszPath As String, ByVal lpPrefixString As String, ByVal wUnique As Long, ByVal lpTempFileName As String) As Long

Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

'
' - - -
'


'........................................
'Name: MakeLong
'Description:
'........................................
Public Function MakeLong(LoWord As Integer, HiWord As Integer) As Long
  'Combines two integers into a long integer
  MakeLong = LoWord + (65536 * HiWord)
End Function


'........................................
'Name: HiWord
'Description:
'........................................
Function HiWord(dw As Long) As Integer
    If dw And &H80000000 Then
        HiWord = (dw \ 65535) - 1
    Else
        HiWord = dw \ 65535
    End If
End Function


'........................................
'Name: LoWord
'Description:
'........................................
Function LoWord(dw As Long) As Integer
    If dw And &H8000& Then
        LoWord = &H8000 Or (dw And &H7FFF&)
    Else
        LoWord = dw And &HFFFF&
    End If
End Function


'........................................
'Name: MyWndProc
'Description:
'........................................
Function MyWndProc(ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
'// Subclassa la form per interecttare i messaggi

    On Error Resume Next
    Dim retVal As Long
    Dim MinMaxDest As MINMAXINFO
    Dim Mouse_X As Integer             '// Coordinate del mouse
    Dim Mouse_Y As Integer    '// Quale messaggio abbiamo ricevuto?
    Select Case msg
        Case WM_GETMINMAXINFO
            '// lParam contiene un puntatore (cio un indirizzo di memoria
            '// ad una struttura MINMAXINFO. VB non ha puntatori, quindi
            '// dobbiamo copiare ci che  contenuto in memoria alla
            '// locazione lParam alla locazione che punta a MinMaxDest
            '// (noi in realt passiamo l'indirizzo della variabile
            '// MinMaxDest, perch passiamo ByRef -default in VB)
            CopyMemoryFromPointer MinMaxDest, lParam, Len(MinMaxDest)
            '// Ora in x c' la width massima, e in y la height massima.
            '// Prima li cambiamo, settandoli ai valori che vogliamo.
            MinMaxDest.ptMaxTrackSize.X = MAX_WIDTH
            MinMaxDest.ptMaxTrackSize.Y = MAX_HEIGHT
            MinMaxDest.ptMinTrackSize.X = MIN_WIDTH
            MinMaxDest.ptMinTrackSize.Y = MIN_HEIGHT
            '// Poi ricopiamo i nuovi valori, cio la memoria che c' alla
            '// locazione che punta a MinMaxDest, in lParam. Siccome ilvalore
            '// lParam  gi un puntatore, dobbiamo passarlo byval,altrimenti
            '// VB crea un'altra variabile che contiene il numero longlParam
            '// e passa alla funzione l'indirizzo di questa variabile:CRASH!
            CopyMemory ByVal lParam, MinMaxDest, Len(MinMaxDest)
            '// Non passiamo alla window procedure standard.
            retVal = 0
        Case WM_NCHITTEST       '// Qualsiasi azione di mouse
            '// chiamiamo prima la windowProcedure standard, che ci dir su
            '// quale parte della form si trova il mouse (valore in RetVal)
            retVal = CallWindowProc(g_OldWndProc, hwnd, msg, wParam, lParam)
            '// in lparam ci sono le coordinate del mouse
            Mouse_X = LoWord(lParam)
            Mouse_Y = HiWord(lParam)
            '// Se il mouse  sulla client area, mentiamo a Windows, dicendo
            '// che invece si trova sulla barra del titolo, cos Windows
            '// attiver il Drag automatico. Funziona anche se la finestra
            '// non ha barra del titolo!
            If retVal = HTCLIENT Then       '// azione sulla client area
                retVal = HTCAPTION          '// Dice a Windows che l'azione  avvenuta sulla barra del titolo.
            End If
        Case Else       '// Altri messaggi che si volessero intercettare
            '// azioni conseguenti. In ogni caso lasciamo processare glialtri
            '// messaggi in maniera standard
            retVal = CallWindowProc(g_OldWndProc, hwnd, msg, wParam, lParam)
    End Select    '// Ritorna retVal
    MyWndProc = retVal
End Function


'
' - - - -
'


'........................................
'Name: GenTempName
'Description:
'........................................
Public Function GenTempName(Optional sPath As String) As String
Dim sPrefix As String
Dim lUnique As Long
Dim sTempFileName As String
    
    If Len(sPath) = 0 Then sPath = GetTmpPath 'change to a valid path
    sPrefix = "sfR"
    lUnique = 0
    sTempFileName = Space$(100)
    GetTempFileName sPath, sPrefix, lUnique, sTempFileName
    sTempFileName = Mid$(sTempFileName, 1, InStr(sTempFileName, Chr$(0)) - 1)
    GenTempName = sTempFileName

End Function


'........................................
'Name: GetTmpPath
'Description:
'........................................
Public Function GetTmpPath() As String
    Dim strFolder As String
    Dim lngResult As Long
    strFolder = String(MAX_PATH, 0)
    lngResult = GetTempPath(MAX_PATH, strFolder)
    If lngResult <> 0 Then
        GetTmpPath = Left$(strFolder, InStr(strFolder, Chr(0)) - 1)
    Else
        GetTmpPath = ""
    End If
End Function


'This Procedure will Either Retrieve or Save Form Posn values
'Best used on Form Load and Unload or QueryUnLoad
Public Sub FormWinRegPos(pMyForm As Form, Optional pbSave As Boolean, Optional sSectionName As String)
On Error GoTo EH
    
    Dim iWS As Integer
    
    If Len(sSectionName) = 0 Then
        sSectionName = App.EXEName
    End If
    
    With pMyForm
        
        If pbSave Then
            iWS = .WindowState
            If .WindowState = vbMinimized Or .WindowState = vbMaximized Then
                .WindowState = vbNormal
            End If
            'Save AppName...FrmName...KeyName...Value
            SaveSetting sSectionName, .Name, "LTWHS", .Left & "" _
                                                   & .Top & "" _
                                                   & .Width & "" _
                                                   & .Height & "" _
                                                   & iWS
        Else
            sSectionName = GetSetting(sSectionName, .Name, "LTWHS", "15511551442585350")
            .Left = GetToken(sSectionName, "")
            .Top = GetToken("", "")
            .Width = GetToken("", "")
            .Height = GetToken("", "")
            .WindowState = GetToken("", "")
        End If
    
    End With
    
    Exit Sub

EH:
    MsgBox "Error " & Err.Number & vbCrLf & vbCrLf & Err.Description

End Sub


Public Function IsInDebugMode() As Boolean
On Error GoTo ErrorHandler
Debug.Print 1 / 0
Exit Function
ErrorHandler:
If Err.Number = 11 Then
IsInDebugMode = True
End If
End Function


'Fully commented by DNA CodeBook
'CopyRight 2001-2002 by DNA CodeBook - All Right Reserved
